diff -Nru apt-0.9.7.5ubuntu5.2/apt-pkg/cachefile.cc apt-0.9.7.5ubuntu5.2+gthomas1/apt-pkg/cachefile.cc
--- apt-0.9.7.5ubuntu5.2/apt-pkg/cachefile.cc	2012-11-01 02:48:40.000000000 -0700
+++ apt-0.9.7.5ubuntu5.2+gthomas1/apt-pkg/cachefile.cc	2013-03-04 18:22:17.000000000 -0800
@@ -110,6 +110,20 @@
    return true;
 }
 									/*}}}*/
+// CacheFile::BuildSourceListFile - Open and build one sources.list file/*{{{*/
+// ---------------------------------------------------------------------
+/* */
+bool pkgCacheFile::BuildSourceListFile(std::string file, OpProgress *Progress)
+{
+   if (SrcList != NULL)
+      return true;
+
+   SrcList = new pkgSourceList();
+   if (SrcList->Read(file) == false)
+      return _error->Error(_("The list of sources could not be read."));
+   return true;
+}
+									/*}}}*/
 // CacheFile::BuildPolicy - Open and build all relevant preferences	/*{{{*/
 // ---------------------------------------------------------------------
 /* */
diff -Nru apt-0.9.7.5ubuntu5.2/apt-pkg/cachefile.h apt-0.9.7.5ubuntu5.2+gthomas1/apt-pkg/cachefile.h
--- apt-0.9.7.5ubuntu5.2/apt-pkg/cachefile.h	2012-11-01 02:48:40.000000000 -0700
+++ apt-0.9.7.5ubuntu5.2+gthomas1/apt-pkg/cachefile.h	2013-03-04 18:22:12.000000000 -0800
@@ -62,6 +62,7 @@
    bool BuildCaches(OpProgress *Progress = NULL,bool WithLock = true);
    __deprecated bool BuildCaches(OpProgress &Progress,bool const &WithLock = true) { return BuildCaches(&Progress, WithLock); };
    bool BuildSourceList(OpProgress *Progress = NULL);
+   bool BuildSourceListFile(std::string file, OpProgress *Progress = NULL);
    bool BuildPolicy(OpProgress *Progress = NULL);
    bool BuildDepCache(OpProgress *Progress = NULL);
    bool Open(OpProgress *Progress = NULL, bool WithLock = true);
diff -Nru apt-0.9.7.5ubuntu5.2/cmdline/apt-get.cc apt-0.9.7.5ubuntu5.2+gthomas1/cmdline/apt-get.cc
--- apt-0.9.7.5ubuntu5.2/cmdline/apt-get.cc	2012-11-09 00:40:44.000000000 -0800
+++ apt-0.9.7.5ubuntu5.2+gthomas1/cmdline/apt-get.cc	2013-03-04 18:21:04.000000000 -0800
@@ -1641,14 +1641,19 @@
 /* */
 bool DoUpdate(CommandLine &CmdL)
 {
-   if (CmdL.FileSize() != 1)
-      return _error->Error(_("The update command takes no arguments"));
+   if (CmdL.FileSize() > 2)
+      return _error->Error(_("The update command takes at most one argument"));
 
    CacheFile Cache;
 
    // Get the source list
-   if (Cache.BuildSourceList() == false)
-      return false;
+   if (CmdL.FileSize() == 2) {
+      if (Cache.BuildSourceListFile(CmdL.FileList[1]) == false)
+         return false;
+   } else {
+      if (Cache.BuildSourceList() == false)
+         return false;
+   }
    pkgSourceList *List = Cache.GetSourceList();
 
    // Create the progress
